<?
/*----------------------------- start title -----------------------------------

ADC2000NG Pro - banner exchange software
Copyright (C) 1998-2010  T&D Systems, Inc.
http://www.td-systems.com/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

* Gloval variables and classes module
-------------------------------- end title ----------------------------------*/
include("adc_mysql.inc");

// ----| GLOBAL VARIABLES
  $adc_version		= "4.0.2";

  $banner_res		= array(1 => "468x60",
                                2 => "100x100",
                                3 => "120x60");

  $swmbanner_res	= array(1 => "100x100");

  // ----| Don't change it!
  $banner_type		= array(1 => "Image banner",
                                2 => "Java banner",
                                3 => "Flash banner",
                                4 => "HTML banner",
                                5 => "Swim-banner");

  $file_types		= array(1 => ".GIF or .JPG",
                                2 => ".SWF",
                                3 => ".CLASS");

  // -----| Jumpers
  $CENGINE_flag		= 0;	// 1 - I have the C-Engine
  $SWM_flag		= 1;	// 1 - I have the Swim-banner module
  $GD_flag		= 1;	// 1 - I have the GD library on my site
  $FLASH_flag		= 1;	// 1 - I have the FLASH module
  $context_help		= 1;	// 1 - in use
  $sub_banner		= 1;	// 1 - in use
  $opacity_flag		= 1;	// 1 - in use (Transparent for step-controls)
  $ban_validator	= 1; 	// 1 - in use (validator for "Banner's name" field in Banner management area)
  $blzcrdec_flag	= 1;	// 1 - in use (Then substract amount of blitz credits from regular credits amount)
  $counter_file		= 1;	// 1 - in use (Loading background for counter from banners/adc2000/counter.png)

  $pop_height		= 40;	// Height for top-frame of PopUp Exchange
  $strx_height		= 40;	// Height for top-frame of StartPage Exchange

  $php_version		= 4;	// PHP3/PHP4

  $autorefresh		= 30;	// Autorefresh time in seconds
  $subheight		= 20;	// Sub-banner height
  $uresult_out		= 24;	// Result lineout (0..) for users
  $bresult_out		= 9;	// Result lineout (0..) for banners
  $ina_time		= 3;	// Inactive time (in days)

  $def_lang		= "english";			// Default language

  $adc_domain		= "http://127.0.0.1:8080/";	// Domain and port for c-engine
  $pop_topframe		= "http://127.0.0.1/adc2000ng/pop_topframe.html";	// URL for Top frame of PopUp Exchange
  $strx_topframe	= "http://127.0.0.1/adc2000ng/strx_topframe.phtml";	// URL for Top frame of StartPage Exchange

  // ----| Default values
  $main_grp		= "Main group";	// Main banners group
  $auto_grp		= "Group";	// Autoname for Quick Start module
  $fext			= ".php";	// File extension
  $page_header		= "ADCenter2000 Next Generation";
  $copyright		= "Copyright (C)&nbsp;T&amp;D Systems Inc. 2000 All Rights Reserved.";

  // ----| SQL Database settings
  class ADC_sql extends CSql {
    var $db_host	= "127.0.0.1";	// SQL Server host
    var $db_name	= "adc2000ng";	// Database name
    var $db_user	= "root";	// Database user
    var $db_pass	= "";		// Database password
    //var $Debug	= $debug_flag;
  }

  // ----| Available langpacks
  $laguages	= array("english:english.inc:help.eng");

  define("INCOMING","./banners/");	// Where to move the uploaded files to?
  define("LANGPACK","langpack/");	// Langpack's directory
  define("ADCSYS","adc2000/");		// System's directory

  define("FLASHEXT",".swf");		// Flash file's extantion
  define("JAVAEXT",".class");		// Java file's extantion
  define("JSEXT",".js");		// JavaScript file's extantion

  define("OWNER","adc.jpg");		// Default banner
  define("NETWORK","network.jpg");	// Default sub-banner
  define("FLASHNETWORK","network.swf");	// Default FLASH sub-banner
  define("SYSLOCK","syslock.jpg");	// System lock banner

  // ----| Debug module
  $debug_flag		= 0;	// 0 - no debug information (don't change it!)
  $debug_onlytime	= 0;	// 0 - no debug information (don't change it!)
  $debug_nomail		= 1;	// 0 - no debug information (don't change it!)
  $demo_mode		= 0;

// ----| FUNCTIONS
function lastday($month, $year) {
  $lastday=date("d",mktime(0,0,0,$month+1,0,$year));
  return($lastday);
}

function select_parse($str_in, $delimiter) {
  $options = split("[$delimiter]+", $str_in);
  for($ix = 0; $options[$ix]; $ix++)
    $retx[$ix] = $options[$ix];
  return $retx;
}  

function make_seed() {
  list($usec, $sec) = explode(' ', microtime());
  return (float) $sec + ((float) $usec * 100000);
}

// ----| CLASSES
class Exploder {
  var $m_segments;
  function Exploder($tokens, $string) {
    $string = stripslashes($string);
    $start = true;
    for ($i=0; $i < strlen($string); $i++) {
      for ($t=0; $t < count($tokens); $t++) {
        if ($string[$i] == $tokens[$t]) {
          if ($start) {
            $this->m_segments[] = $segment;
            unset($segment);
          }
          $start = false;
          break;
        }
      }
      if ($t == count($tokens))
          $start = true;
      if ($start)
          $segment .= $string[$i];
    }
    if ($start)
      $this->m_segments[] = $segment;
  }
  function GetSegments() {
    return $this->m_segments;
  }
  function GetNumber() {
    return count($this->m_segments);
  }
}

class CTimer {
  var $t_start   = 0;
  var $t_stop    = 0;
  var $t_elapsed = 0;
  function start() {
    $this->t_start = microtime();
  }
  function stop() {
    $this->t_stop  = microtime();
  }
  function elapsed() {
    if ($this->t_elapsed) {
      return $this->t_elapsed;
    }
    else {
      $start_u = substr($this->t_start,0,10);
      $start_s = substr($this->t_start,11,10);
      $stop_u  = substr($this->t_stop,0,10);
      $stop_s  = substr($this->t_stop,11,10);
      $start_total = doubleval($start_u) + $start_s;
      $stop_total  = doubleval($stop_u) + $stop_s;
      $this->t_elapsed = $stop_total - $start_total;
      return $this->t_elapsed;
    }
  }
}

class CTrigger {
  var $tr_status = 0;
  function sw() {
    if ($this->tr_status)
      $this->tr_status = 0;
    else
      $this->tr_status = 1;
    return $this->tr_status;
  }
}
?>
