<?
/*----------------------------- start title -----------------------------------

ADC2000NG Pro - banner exchange software
Copyright (C) 1998-2010  T&D Systems, Inc.
http://www.td-systems.com/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

* Redirection module
------------------------------- end title -----------------------------------*/
include("adc2000ng.inc");
Header("Cache-Control: no-cache, must-revalidate");

if ($debug_flag || $debug_onlytime) {
//  $timer = new c_Timer; 
//  $timer->start(); 
}

if ($_GET['bid'])
  $bid = $_GET['bid'];
else
  $bid = $_POST['bid'];

if ($debug_flag) {
  echo "Debug info: ----------| <b>Incoming information #1</b><br>\n";
  echo "Debug info: UID: $uid<br>\n";
  echo "Debug info: BANUID: $buid<br>\n";
  echo "Debug info: Banner ID: $bid<br>\n";
  echo "Debug info: Target URL: $turl<br>\n";
}

// ----| Connect to database
$dbase = new ADC_sql;
$dbase->connect();

if (!$uid || !$bid) {
  $coo_string = select_parse($HTTP_COOKIE,"; ");
  $num_coo = count($coo_string);
  for ($i=0; $i<$num_coo; $i++) {
    $coo = select_parse($coo_string[$i],"=");
    switch ($coo[0]) {
     case "bid":
       $dbase->query("select ban_id from banner where ban_id=$coo[1] and ban_url='$turl'");
       list($bid) = $dbase->fetch();
       break;
    }
  }
  if ($bid) {
    for ($i=0; $i<$num_coo; $i++) {
      $coo = select_parse($coo_string[$i],"=");
      switch ($coo[0]) {
       case "uid$bid":
         $uid = $coo[1];
         break;
      }
    }
  }
}

if ($debug_flag) {
  echo "Debug info: ----------| <b>Incoming information #2</b><br>\n";
  echo "Debug info: UID: $uid<br>\n";
  echo "Debug info: BANUID: $buid<br>\n";
  echo "Debug info: Banner ID: $bid<br>\n";
  echo "Debug info: Target URL: $turl<br>\n";
}

if (!$uid || !$buid || !$bid) {
  include("adc2000h.inc");
  $TITLE = "ERROR";
  $MSG = "<b>ACCESS DENIED</b>";
  page_header();
  include("adcmessage.inc");
  page_footer();
  exit();
}

$dbase->query("select sys_lock,lock_flag,adc_dir,clkexch_flag,log_ref,log_agent,clicks_pb,ip_limit,alz_flag from server_set");
list($sys_lock,$lock_flag,$adc_dir,$clkexch_flag,$log_ref,$log_agent,$clicks_pb,$ip_limit,$alz_flag) = $dbase->fetch();

if ($debug_flag) {
  echo "Debug info: -----------------------<br>\n";
  echo "Debug info: SYSLOCK: $sys_lock<br>\n";
  echo "Debug info: LOCKFLAG: $lock_flag<br>\n";
  echo "Debug info: ADC Dir: $adc_dir<br>\n";
}

if ($sys_lock) {
  Header("Location: $adc_dir");
  exit();
}

// ----| Cheat Analyzer
if ($alz_flag) {
  $ccd = 0; $lackofccd = 0; $coo_string = 0; $num_coo = 0;
  $log_date = date(D." ".M." ".d." ".H.":".i.":".s." ".Y);
  if ($HTTP_X_FORWARDED_FOR) $user_ip = $HTTP_X_FORWARDED_FOR;
  else $user_ip = $REMOTE_ADDR;
  $coo_string = select_parse($HTTP_COOKIE,"; ");
  $num_coo = count($coo_string);
  for ($i=0; $i<$num_coo; $i++) {
    $coo = select_parse($coo_string[$i],"=");
    switch ($coo[0]) {
     case "sr_clc$uid":
       if ($coo[1] >= $clicks_pb) {
         $new_clcv = $coo[1] + 1;
         $dbase->query("insert into user_logs values ($uid,'$log_date','Clicks quota is exceed (CLC:$new_clcv)','$user_ip')");
       }
       else
         $new_clcv = $coo[1] + 1;
       break;
     case "sr_ip$uid":
       $ip_str = select_parse($coo[1],"|");
       $num_ip = count($ip_str);
       for ($i=0;$i<$num_ip;$i++) {
         if ($user_ip != $ip_str[$i]) $lackofccd++;
         else $ccd++;
       }
       if ($lackofccd == $num_ip) {
         if ($ccd == 0)
           $newip_str = $coo[1]."|".$user_ip;
         else
           $newip_str = $coo[1];
       }
       else {
         if ($ccd != 0)
           $newip_str = $coo[1];
       }
       if ($lackofccd >= $ip_limit)
         $dbase->query("insert into user_logs values ($uid,'$log_date','IPs quota is exceed (IPs:$lackofccd)','$user_ip')");
       break;
    }
  }
  if (!$new_clcv) $new_clcv = 1;
  if (!$newip_str) $newip_str = $user_ip;
  SetCookie("sr_clc$uid","$new_clcv");
  SetCookie("sr_ip$uid","$ip_str");
  
  if ($log_ref) {
    if (!$HTTP_REFERER)
      $dbase->query("insert into user_logs values ($uid,'$log_date','Cant resolve referer address','$user_ip')");
  }
  if ($log_agent) {
    if (!$HTTP_USER_AGENT)
      $dbase->query("insert into user_logs values ($uid,'$log_date','Cant resolve user agent','$user_ip')");
  }
}
// -------------------

// ----| Lock the tables
if ($lock_flg) {
  $dbase->lock(ext_stats);
  $dbase->lock(banner);
  $dbase->lock(ban_group);
  $dbase->lock(total_stats);
  $dbase->lock(credits);
  $dbase->lock(credit_stats);
  $dbase->lock(h_cstats);
  $dbase->lock(d_cstats);
  $dbase->lock(m_cstats);
}

// ----| Add information to Total Stats
$dbase->query("select t_clicks,td_clicks,tc_day,ty_clicks,td_impress,ty_impress from total_stats");
list($t_clicks,$td_clicks,$tc_day,$ty_clicks,$td_impress,$ty_impress) = $dbase->fetch();
$c_day = date(Y."-".m."-".d);
if ($c_day != $tc_day) {
  if ($tc_day != date(Y."-".m."-".d,mktime(0,0,0,date("m"),date("d")-1,date("Y")))) {
    $ty_impress = 0;
    $ty_clicks  = 0;
  }
  else {
    $ty_impress = $td_impress;
    $ty_clicks  = $td_clicks;
  }
  $td_clicks  = 1;
  $td_impress = 0;
  if ($debug_flag) {
    echo "Debug info: (Total Stats) today clicks = 1<br>\n";
    echo "Debug info: (Total Stats) yesterday clicks = $ty_clicks<br>\n";
  }
}
else {
  $td_clicks += 1;
  if ($debug_flag) echo "Debug info: (Total Stats) today clicks = $td_clicks<br>\n";
}

// ----| Increase Total Clicks
$t_clicks += 1;
if ($debug_flag) echo "Debug info: (Total Stats) total clicks = $t_clicks<br>\n";

$dbase->query("update total_stats set t_clicks=$t_clicks,td_clicks=$td_clicks,tc_day='$c_day',ty_clicks=$ty_clicks,td_impress=$td_impress,ty_impress=$ty_impress");

// ----| Check user :   
$dbase->query("select usr_aflag,click,impression from user,credits where user.usr_id=$buid and credits.usr_id=$buid");
list($usr_aflag,$cred_click,$cred_impression) = $dbase->fetch();

if ($debug_flag) {
  echo "Debug info:   <br>\n";
  echo "Debug info: usr_aflag = $usr_aflag<br>\n";
  echo "Debug info: cred_click = $cred_click<br>\n";
  echo "Debug info: cred_impression = $cred_impression<br>\n";
}

if ($usr_aflag) {
  if ($cred_click <= 0) {
    // ----| User haven't Click Credits
    if ($cred_impression > 0) {
      // ----| Decrement Impression Credit
      if ($debug_flag) echo "Debug info:  impression = $cred_impression-1<br>\n";
      $dbase->query("update credits set impression=impression-1 where usr_id=$buid and impression>=1");
    }
  }
  else {
    if ($debug_flag) echo "Debug info:  click = $cred_click-1<br>\n";
    $dbase->query("update credits set click=click-1 where usr_id=$buid");
  }

  // ----| Add history information to Stats tables

  // ----| Credit Stats
  $dbase->query("update credit_stats set j_clicks=j_clicks+1,lr_clicks=lr_clicks+1 where usr_id=$buid");

  // ----| Banner table
  $dbase->query("select grp_id from banner where usr_id=$buid and ban_id=$bid");
  list($grp_id) = $dbase->fetch();
  $dbase->query("update banner set ban_clicks=ban_clicks+1 where usr_id=$buid and ban_id=$bid");

  // ----| Banners group table
  // usr_id=$buid and
  $dbase->query("update ban_group set grp_clicks=grp_clicks+1 where grp_id=$grp_id");

  $cr_year = date(Y);
  $cr_month = date(n);
  $cr_month2 = date(m);
  $cr_day = date(j);
  $cr_day2 = date(d);
  $cr_date = $cr_year."-".$cr_month2."-".$cr_day2;

  // ----| Hourly table
  $get_hour = "c_hr".date("H");
  $dbase->query("select ".$get_hour.",c_lu_day from h_cstats where ban_id=$bid and h_date='$cr_date'");
  list($h_click,$c_lu_day) = $dbase->fetch();
  if ($cr_day != $c_lu_day) {
    $dbase->query("insert into h_cstats values ($bid,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$cr_day,'$cr_date')");
    $dbase->query("update h_cstats set ".$get_hour."=1 where ban_id=$bid and h_date='$cr_date'");
    if ($debug_flag) echo "Debug info: new day, h_click = 1<br>\n";
  }
  else {
    // ----| 
    $h_click += 1;
    $dbase->query("update h_cstats set ".$get_hour."=$h_click where ban_id=$bid and h_date='$cr_date'");
    if ($debug_flag) echo "Debug info: current day, h_click=$h_click<br>\n";
  }

  $cr_date = $cr_year."-".$cr_month2;

  // ----| Daily table
  $get_day = "c_ds".date("d");
  $dbase->query("select ".$get_day.",c_lu_month from d_cstats where ban_id=$bid and d_date='$cr_date'");
  list($d_click,$c_lu_month) = $dbase->fetch();
  if ($cr_month != $c_lu_month) {
    $dbase->query("insert into d_cstats values ($bid,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$cr_month,'$cr_date')");
    $dbase->query("update d_cstats set ".$get_day."=1 where ban_id=$bid and d_date='$cr_date'");
    if ($debug_flag) echo "Debug info: new month, d_click = 1<br>\n";
  }
  else {
    // ----| 
    $d_click += 1;
    $dbase->query("update d_cstats set ".$get_day."=$d_click where ban_id=$bid and d_date='$cr_date'");
    if ($debug_flag) echo "Debug info: current month, d_click=$d_click<br>\n";
  }

  // ----| Monthly table
  $get_month = "c_ms".date("m");
  $dbase->query("select ".$get_month.",c_lu_year from m_cstats where ban_id=$bid and c_lu_year=$cr_year");
  list($m_click,$c_lu_year) = $dbase->fetch();
  if ($cr_year != $c_lu_year) {
    $dbase->query("insert into m_cstats values ($bid,0,0,0,0,0,0,0,0,0,0,0,0,$cr_year)");
    $dbase->query("update m_cstats set ".$get_month."=1 where ban_id=$bid and c_lu_year='$cr_year'");
    if ($debug_flag) echo "Debug info: new year, m_click = 1<br>\n";
  }
  else {
    // ----| 
    $m_click += 1;
    $dbase->query("update m_cstats set ".$get_month."=$m_click where ban_id=$bid and c_lu_year='$cr_year'");
    if ($debug_flag) echo "Debug info: current year, m_click=$m_click<br>\n";
  }
}

// ----|  impression  ( -)
$dbase->query("select usr_aflag,impression,clk_ratio from user,credits where user.usr_id=$uid and credits.usr_id=$uid");
list($usr_aflag,$impression,$click_ratio) = $dbase->fetch();
if ($usr_aflag) {
  list($ratio_x,$ratio_y) = select_parse($click_ratio,":");
  if (!$ratio_y) $click_ratio = $ratio_x;
  else $click_ratio = $ratio_x/$ratio_y;
  if ($debug_flag) echo "Debug info: Click ratio: $click_ratio<br>\n";

  // ----|  click  (   click exchange)
  if ($clkexch_flag) {
    $dbase->query("update credits set click=click+$click_ratio where usr_id=$uid");
  }
  else {
    $dbase->query("update credits set impression=impression+$click_ratio where usr_id=$uid");
  }
}

// ----|  Affiliate 
$dbase->query("select afl_clicks from credit_stats where usr_id=$uid");
list($afl_clicks) = $dbase->fetch();
$afl_clicks += 1;
$dbase->query("update credit_stats set afl_clicks=afl_clicks+1 where usr_id=$uid");
if ($debug_flag) echo "Debug info: afl_clicks = $afl_clicks<br>\n";

if ($lock_flag) $dbase->unlock();

if (!$turl) {
  // ----| Get banner url
  $dbase->query("select ban_url from banner where ban_id=$bid");
  list($turl) = $dbase->fetch();
}

// ----| Extended Stats table
$dbase->query("select ban_id from ext_stats where ws_id=$uid and bo_id=$buid and ban_id=$bid");
$num_exts = $dbase->num_rows();
if (!$num_exts)
  $dbase->query("insert into ext_stats values ($uid,$buid,$bid,0,1)");
else
  $dbase->query("update ext_stats set ban_clicks=ban_clicks+1 where ws_id=$uid and bo_id=$buid and ban_id=$bid");

$dbase->free();

if ($debug_flag) {
  echo "Debug info: Go to site $turl<br>\n";
  $timer->stop();
  echo "<b>Total time: ".$timer->elapsed()."</b><br>\n";
  echo "---| SHUTDOWN |---<br>\n";
}
else
  Header("Location: $turl");
?>
